//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private MQTNotas[] cacheMQTNotas = null;

        private static MQTNotas checkMQTNotas = new MQTNotas();

        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        public MQTNotas MQTNotas()
        {
            return MQTNotas(Input);
        }

        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        public MQTNotas MQTNotas(Data.IDataSeries input)
        {
            if (cacheMQTNotas != null)
                for (int idx = 0; idx < cacheMQTNotas.Length; idx++)
                    if (cacheMQTNotas[idx].EqualsInput(input))
                        return cacheMQTNotas[idx];

            lock (checkMQTNotas)
            {
                if (cacheMQTNotas != null)
                    for (int idx = 0; idx < cacheMQTNotas.Length; idx++)
                        if (cacheMQTNotas[idx].EqualsInput(input))
                            return cacheMQTNotas[idx];

                MQTNotas indicator = new MQTNotas();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                MQTNotas[] tmp = new MQTNotas[cacheMQTNotas == null ? 1 : cacheMQTNotas.Length + 1];
                if (cacheMQTNotas != null)
                    cacheMQTNotas.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheMQTNotas = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MQTNotas MQTNotas()
        {
            return _indicator.MQTNotas(Input);
        }

        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        public Indicator.MQTNotas MQTNotas(Data.IDataSeries input)
        {
            return _indicator.MQTNotas(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.MQTNotas MQTNotas()
        {
            return _indicator.MQTNotas(Input);
        }

        /// <summary>
        /// MQTNotas - www.masquetrading.com - Escribe notas en tus gráficos. Control-Shift cambia entre visibilidad compacta y expandida
        /// </summary>
        /// <returns></returns>
        public Indicator.MQTNotas MQTNotas(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.MQTNotas(input);
        }
    }
}
#endregion
